//---------------------------------------------------------------------------

#ifndef SampleDocObjectsH
#define SampleDocObjectsH

#include <Classes.hpp>
#include <Graphics.hpp>

#include <RVDocParams.hpp>
#include <RVItem.hpp>


//---------------------------------------------------------------------------

class TSampleDocObject1 : public TRVDocObject
{
  private:
	TPicture* FThumbnail;
	__fastcall void SetThumbnail(TPicture* Value);
  public:
	__fastcall virtual TSampleDocObject1(System::Classes::TCollection* ACollection);
	__fastcall virtual ~TSampleDocObject1(void);
	DYNAMIC void __fastcall Assign(Rvitem::TCustomRVItemInfo* Source);
  __published:
	__property Vcl::Graphics::TPicture* Thumbnail =
	  {read=FThumbnail, write=SetThumbnail};
};

class TSampleDocObject2 : public TRVDocObject
{
  private:
	String    FSignature;
	TDateTime FDate;
  public:
  	__fastcall virtual TSampleDocObject2(System::Classes::TCollection* ACollection);
	DYNAMIC void __fastcall Assign(Rvitem::TCustomRVItemInfo* Source);
  __published:
	__property String Signature = {read=FSignature, write=FSignature};
	__property TDateTime Date = {read=FDate, write=FDate};
};




#endif
