//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SampleDocObjects.h"

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "RichView"
#pragma link "RVEdit"
#pragma link "RVScroll"
#pragma link "RVStyle"
#pragma resource "*.dfm"
TForm13 *Form13;
//---------------------------------------------------------------------------
__fastcall TForm13::TForm13(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm13::CreateSampleDocument()
{
  RichViewEdit1->Clear();
  TSampleDocObject1* DocObject1 = new TSampleDocObject1(RichViewEdit1->DocObjects);
  DocObject1->Thumbnail = Image1->Picture;
  TSampleDocObject2* DocObject2 = new TSampleDocObject2(RichViewEdit1->DocObjects);
  DocObject2->Signature = "It's me!";
  DocObject2->Date = Date();
  RichViewEdit1->AddNL("DocObjects Test", 1, 1);
  RichViewEdit1->AddNL("This document contains two invisible objects."
   "Object1 includes a picture. Object2 includes a text and a date. "
   "Click the button below to save this document in a stream, and load "
   "this stream in the second editor.", 0, 0);
  RichViewEdit1->Format();
}
void __fastcall TForm13::FormCreate(TObject *Sender)
{
  CreateSampleDocument();
}
//---------------------------------------------------------------------------
void __fastcall TForm13::Button1Click(TObject *Sender)
{
  // copying from RichViewEdit1 to RichViewEdit2
  TMemoryStream* Stream = new TMemoryStream;
  RichViewEdit1->SaveRVFToStream(Stream, false);
  Stream->Position = 0;
  RichViewEdit2->LoadRVFFromStream(Stream);
  RichViewEdit2->Format();
  // showing DocObjects from RichViewEdit2
  Image2->Picture = NULL;
  LabelS->Caption = "Signature:";
  LabelD->Caption = "Date:";
  for (int i = 0; i < RichViewEdit2->DocObjects->Count; i++)
  {
	TRVDocObject* Item = (TRVDocObject*)(RichViewEdit2->DocObjects->Items[i]);
	if (Item->InheritsFrom(__classid(TSampleDocObject1)))
	{
	  Image2->Picture = ((TSampleDocObject1*)Item)->Thumbnail;
	}
	else if (Item->InheritsFrom(__classid(TSampleDocObject2)))
	{
	  LabelS->Caption = "Signature: " +
		((TSampleDocObject2*)Item)->Signature;
	  LabelD->Caption = "Date: " +
		DateToStr(((TSampleDocObject2*)Item)->Date);
	}
  }
}
//---------------------------------------------------------------------------
